/* 1- Esta aplicacin permite convertir kilmetros en millas. El programa principal se encuentra en el archivo main.c. La conversin se lleva a cabo llamando a la funcin convertir() en conversion.c (y cuyo prototipo est definido en el archivo de cabecera conversion.h). Por ltimo, para imprimir el resultado se invoca a la funcin imprimir_resultado() en impresion.c (y cuyo prototipo est definido en el archivo de cabecera impresion.h).El grafo de dependencias es el siguiente*/

/*El makefile se construy usando reglas de inferencia, aprovechando que los archivos de dependencias (main.c, conversion.c e impresion.c) y los objetivos (main.o, conversion.o e impresion.o) tienen el mismo nombre. Obsrvese que en el makefile se incluye una regla adicional cuyo objetivo es clean. Esta regla permite borrar todos los archivos generados en la compilacin del proyecto, mediante el comando: make clean. Como puede verse, esta regla no tiene dependencia alguna y su comando asociado es rm *.o ejemplo (para eliminar todos los archivos con extensin .o y el ejecutable ejemplo). El comando rm (remove) permite eliminar archivos en ambientes Unix/Linux; en el caso de Windows el comando equivalente es del/.*/

main.c

#include <stdio.h>
#include "conversion.h"
#include "impresion.h"

int main (void)
{
	int kms;
	float millas;

	printf("Conversin de kilmetros a millas\n");
	printf("---------------------------------\n\n");

	printf("Introduzca la cant. de kms a convertir: ");
	scanf("%i", &kms);

	millas = convertir(kms);
	imprimir_resultado(kms, millas);
	return 0;
}

conversion.h

#define FACTOR 0.6214

/* Prototipos */
float convertir(int);

conversion.c

#include "conversion.h"

float convertir(int kms)
{
	return FACTOR * kms;
}

impresion.h

/* Prototipos */
void imprimir_resultado(int,float);

impresion.c

#include <stdio.h>
void imprimir_resultado(int km, float millas)
{
	printf("%d km equivalen a %.2f millas", km, millas);
}

Makefile

CC=gcc
CFLAGS=-Wall -ansi -pedantic

ejemplo: main.o conversion.o impresion.o
$(CC) -o ejemplo main.o conversion.o impresion.o

# REGLA DE INFERENCIA
# Esta forma es equivalente a: %.o : %.c
# La macro '$<' es el archivo fuente del cual el objetivo
# depende (por ejemplo, conversion.c).
.c.o:
	$(CC) $(CFLAGS) -c $<

clean:
rm *.o ejemplo